--- layout: documentation title: Aquery (Action Graph Query) ---

# Aquery (Action Graph Query)

- Overview
- Basic Syntax
- Aquery Functions
- Options
- Other Tools and Features
  - Querying Against the State of Skyframe
  - Comparing Aquery Outputs
  - Handling Aspect-on-aspect
- Known Issues
- Updates

## Overview

The `aquery` command allows you to query for actions in your build graph. It operates on the post-analysis Configured Target Graph and exposes information about Actions, Artifacts and their relationships.

`aquery` is useful when we are interested in the properties of the Actions/Artifacts generated from the Configured Target Graph. For example, the actual commands run and their inputs/outputs/mnemonics.

The tool accepts several command-line options. Notably, the aquery command runs on top of a regular Bazel build and inherits the set of options available during a build.

It supports the same set of functions that is also available to traditional `query` but `siblings`, `buildfiles` and `tests`.

An example `aquery` output (without specific details):

    $ bazel aquery 'deps(//some:label)'
    action 'Writing file some_file_name'
      Mnemonic: ...
      Target: ...
      Configuration: ...
      ActionKey: ...
      Inputs: [...]
      Outputs: [...]

## Basic Syntax

A simple example of the syntax for `aquery` is as follows:

`bazel aquery "aquery_function(function(//target))"`

The query expression (in quotes) consists of the following:

- `aquery_function(...)`: functions specific to `aquery`. More details below.
- `function(...)`: the standard functions as traditional `query`.
- `//target` is the label to the interested target.

    # aquery examples:
    # Get the action graph generated while building //src/target_a
    $ bazel aquery '//src/target_a'

    # Get the action graph generated while building all dependencies of //src/target_a
    $ bazel aquery 'deps(//src/target_a)'

    # Get the action graph generated while building all dependencies of //src/target_a
    # whose inputs filenames match the regex ".*cpp".
    $ bazel aquery 'inputs(".*cpp", deps(//src/target_a))'

## Aquery Functions

There are currently 3 `aquery` functions:

- `inputs`: filter actions by inputs.
- `outputs`: filter actions by outputs
- `mnemonic`: filter actions by mnemonic

`expr ::= inputs(word, expr)`

The `inputs` operator returns the actions generated from building `expr`, whose input filenames match the regex provided by `word`.

`$ bazel aquery 'inputs(".*cpp", deps(//src/target_a))'`

`outputs` and `mnemonic` functions share a similar syntax.

You can also combine functions to achieve the AND operation. For example:

      $ bazel aquery 'mnemonic("Cpp.*", (inputs(".*cpp", inputs("foo.*", //src/target_a))))'

The above command would find all actions involved in building `//src/target_a`, whose mnemonics match `"Cpp.*"` and inputs match the patterns `".*cpp"` and `"foo.*"`.

### Important: aquery functions can't be nested inside non-aquery functions

- Conceptually this makes sense since the output of aquery functions is Actions, not Configured Targets.
- An example of the syntax error produced:

              $ bazel aquery 'deps(inputs(".*cpp", //src/target_a))'
              ERROR: aquery filter functions (inputs, outputs, mnemonic) produce actions,
              and therefore can't be the input of other function types: deps
              deps(inputs(".*cpp", //src/target_a))

## Options

### Build Options

`aquery` runs on top of a regular Bazel build and thus inherits the set of options available during a build.

### Aquery options

#### `--output=(text|proto|textproto), default=text`

The default output format (`text`) is human-readable, use `proto` or `textproto` for machine-readable format.

#### `--include_commandline, default=true`

Includes the content of the action command lines in the output (potentially large).

#### `--include_aspects, default=false`

Whether to include Aspect-generated actions in the output.

#### `--include_param_files, default=false`

Include the content of the param files used in the command (potentially large). Warning: Enabling this flag will automatically enable the `--include_commandline` flag.

#### `--skyframe_state, default=false`

Without performing extra analysis, dump the current Action Graph from Skyframe. Note: Specifying a target with `--skyframe_state` is currently not supported. This flag is only available with `--output=proto` or `--output=textproto`.

## Other Tools and Features

### Querying against the state of Skyframe

Skyframe is the evaluation and incrementality model of Bazel. On each instance of Bazel server, Skyframe stores the dependency graph constructed from the previous runs of the Analysis phase.

In some cases, it is useful to query the Action Graph currently on Skyframe. An example use case would be:

1. Run `bazel build //target_a`
2. Run `bazel build //target_b`
3. File `foo.out` was generated.

As a Bazel user, I want to determine if `foo.out` was generated from building `//target_a` or `//target_b`.

One could run `bazel aquery 'outputs("foo.out", //target_a)'` and `bazel aquery 'outputs("foo.out", //target_b)'` to figure out the action responsible for creating `foo.out`, and in turn the target. However, the number of different targets previously built can be larger than 2, which makes running multiple `aquery` commands a hassle.

As an alternative, the `--skyframe_state` flag can be used:

      # List all actions on Skyframe's action graph
      $ bazel aquery --output=proto --skyframe_state

      # or

      # List all actions on Skyframe's action graph, whose output matches "foo.out"
      $ bazel aquery --output=proto --skyframe_state 'outputs("foo.out")'

With `--skyframe_state` mode, `aquery` takes the content of the Action Graph that Skyframe keeps on the current instance of Bazel, (optionally) performs filtering on it and outputs the content, without re-running the analysis phase.

#### Special considerations

##### Output format

`--skyframe_state` is currently only available for `--output=proto` and `--output=textproto`

##### Non-inclusion of target labels in the query expression

Currently, `--skyframe_state` queries the whole action graph that exists on Skyframe, regardless of the targets. Having the target label specified in the query together with `--skyframe_state` is considered a syntax error:

      # WRONG: Target Included
      $ bazel aquery --output=proto --skyframe_state //target_a
      ERROR: Error while parsing '//target_a)': Specifying build target(s) [//target_a] with --skyframe_state is currently not supported.

      # WRONG: Target Included
      $ bazel aquery --output=proto --skyframe_state 'inputs(".*.java", //target_a)'
      ERROR: Error while parsing '//target_a)': Specifying build target(s) [//target_a] with --skyframe_state is currently not supported.

      # CORRECT: Without Target
      $ bazel aquery --output=proto --skyframe_state
      $ bazel aquery --output=proto --skyframe_state 'inputs(".*.java")'

### Comparing Aquery Outputs

You can compare the outputs of two different aquery invocations using the `aquery_differ` tool. For instance: when you make some changes to your rule definition and want to verify that the command lines being run did not change. `aquery_differ` is the tool for that.

The tool is available in the bazelbuild/bazel repository. To use it, clone the repository to your local machine. An example usage:

      $ bazel run //tools/aquery_differ -- \
      --before=/path/to/before.proto \
      --after=/path/to/after.proto \
      --input_type=proto \
      --attrs=cmdline \
      --attrs=inputs

The above command returns the difference between the `before` and `after` aquery outputs: which actions were present in one but not the other, which actions have different command line/inputs in each aquery output, ...). The result of running the above command would be:

      Aquery output 'after' change contains an action that generates the following outputs that aquery output 'before' change doesn't:
      ...
      /list of output files/
      ...

      [cmdline]
      Difference in the action that generates the following output(s):
        /path/to/abc.out
      --- /path/to/before.proto
      +++ /path/to/after.proto
      @@ -1,3 +1,3 @@
        ...
        /cmdline diff, in unified diff format/
        ...

#### Command options

`--before, --after`: The aquery output files to be compared

`--input_type=(proto|text_proto), default=proto`: the format of the input files. We currently support `proto` and `textproto` aquery output.

`--attrs=(cmdline|inputs), default=cmdline`: the attributes of actions to be compared.

### Aspect-on-Aspect

It is possible for Aspects to be applied on top of each other. The aquery output of the action generated by these Aspects would then include the Aspect path, which is the sequence of Aspects applied to the target which generated the action.

An example of Aspect-on-Aspect:

      t0
      ^
      | <- a1
      t1
      ^
      | <- a2
      t2

Let ti be a target of rule ri, which applies an Aspect ai to its dependencies.

Assume that a2 generates an action X when applied to target t0. The text output of `bazel aquery --include_aspects 'deps(//t2)'` for action X would be:

      action ...
      Mnemonic: ...
      Target: //my_pkg:t0
      Configuration: ...
      AspectDescriptors: [//my_pkg:rule.bzl%a2(foo=...)
        -> //my_pkg:rule.bzl%a1(bar=...)]
      ...

This means that action `X` was generated by Aspect `a2` applied onto `a1(t0)`, where `a1(t0)` is the result of Aspect `a1` applied onto target `t0`.

Each `AspectDescriptor` has the following format:

      AspectClass([param=value,...])

`AspectClass` could be the name of the Aspect class (for native Aspects) or `bzl_file%aspect_name` (for Starlark Aspects). `AspectDescriptor` are sorted in topological order of the dependency graph.

## Known Issues

The list of aquery issues/planned features can be found on GitHub.

## Updates

Please contact twerth@google.com and leba@google.com for any issue/feature request.